CREATE OR REPLACE FUNCTION matetree(varchar) RETURNS SETOF varchar AS' --clase
DECLARE
	i		integer;  --contador tabla mate_nodes
	numatt		integer;	
	nodo		integer;  --nodo actual
	ban		integer;  --bandera para el recorrido del arbol
	cp		integer;  --contador de pg_pila
	
		
	Ent		numeric;	
	Ent_clase	numeric;	
	val_fraccion	numeric;
	Gan		numeric;
	G_min		numeric :=999;
	val_ln2		numeric := 0.69314718055994530942; 
	
	sql		text DEFAULT '''';
	sql_g		text DEFAULT '''';	
	txt		text DEFAULT '''';
	rta		text DEFAULT NULL;
			
	rec1		record;
	rec2		record;	
	
BEGIN

	EXECUTE ''ALTER TABLE kdd_clase ADD COLUMN entro numeric(4,4)'';
	
	FOR rec1 IN EXECUTE ''SELECT count(*) AS con FROM kdd_ent'' LOOP
	END LOOP;

	numatt := rec1.con;
	sql := ''SELECT count(*) AS cc FROM kdd_ent GROUP BY '' || $1;
	Ent_clase :=0;

	FOR rec1 IN EXECUTE sql LOOP
		val_fraccion := CAST(rec1.cc as numeric)/CAST(numatt as numeric);
		Ent_clase := Ent_clase - (((val_fraccion) * ln(val_fraccion))/val_ln2);		
	END LOOP;
	

IF Ent_clase > 0 THEN
--**CREA TABLA DE REGLAS

	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''mate_rules'''''' LOOP
		EXECUTE ''DROP TABLE mate_rules'';
	END LOOP;		
	EXECUTE ''CREATE TABLE mate_rules (id int2, atributo int2,valor int2)'';	

--**CREA TABLA AUXILIAR pg_pila

	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''pg_pila'''''' LOOP
		EXECUTE ''DROP TABLE pg_pila'';
	END LOOP;		
	EXECUTE ''CREATE TABLE pg_pila(num int2, nn int2, att varchar, valor int2)'';	
	EXECUTE ''INSERT INTO pg_pila VALUES(0,0,''''''||$1||'''''',-1)'';

--** CREA VISTA
	
	EXECUTE ''SELECT * FROM view_set(''''kdd_clase'''')'';	
	
--**DEFINIR LA RAIZ DEL ARBOL

		sql := ''SELECT attname,attnum FROM pg_class,pg_attribute WHERE ''
			 ||''pg_class.relname=''''kdd_ent''''''	
			 || '' AND pg_attribute.attrelid =  pg_class.oid AND attname !=''''''
			 || $1 || '''''' AND attnum >0 ORDER BY attnum'';
		
		FOR rec1 IN EXECUTE sql LOOP
		
			EXECUTE ''INSERT INTO pg_pila VALUES(1,0,'''''' || rec1.attname || '''''',-1)'';
			
			sql_g := ''SELECT * FROM mate_gain(0,''''''||$1||'''''')'';
			
			FOR rec2 IN EXECUTE sql_g LOOP
				Gan := rec2.mate_gain; 
			END LOOP;
						
			IF Gan < G_min THEN				
				G_min := Gan;
				txt := rec1.attname;
				numatt := rec1.attnum;
			END IF;	
			
			EXECUTE ''DELETE FROM pg_pila WHERE num=1'';
		END LOOP;		
		cp := 0;

--**CREAR NODO RAIZ
	
		FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''mate_nodes'''''' LOOP
			EXECUTE ''DROP TABLE mate_nodes'';	
		END LOOP;
				
		EXECUTE ''CREATE TABLE mate_nodes (nodo int2,padre int2,atributo bpchar,valor int2,hijo int2, herm int2,clase int2)'';

		EXECUTE ''INSERT INTO mate_nodes VALUES(0,-1,'''''' || txt || '''''',-1,-1,-1,-1)'';
		i := 0;

		FOR rec1 IN EXECUTE ''SELECT  ''||txt||'' AS at FROM kdd_ent GROUP BY ''||txt LOOP		
			i := i + 1;
				EXECUTE ''INSERT INTO mate_nodes VALUES(''||i||'',0,'''''' || txt || '''''',''
					||rec1.at||'',-1,''||(i+1)||'',-1)'';				
		END LOOP;		
		EXECUTE ''UPDATE mate_nodes SET herm = -1 WHERE nodo=''||i;

		ban := 1;
		nodo := 1;
		WHILE (ban != 0) LOOP		
			IF ban = 1 THEN
				FOR rec1 IN EXECUTE ''SELECT * FROM mate_nodes WHERE nodo = ''||nodo LOOP
					numatt := rec1.hijo;
					cp := cp +1;
					EXECUTE ''INSERT INTO pg_pila VALUES(''||cp||'',''||rec1.nodo||'',''''''||rec1.atributo||'''''',''||rec1.valor||'')'';
				END LOOP;		

				WHILE (numatt != -1) LOOP
					nodo := rec1.hijo;
					FOR rec1 IN EXECUTE ''SELECT * FROM mate_nodes WHERE nodo = ''||nodo LOOP
						numatt := rec1.hijo;
						cp := cp +1;
						EXECUTE ''INSERT INTO pg_pila VALUES(''||cp||'',''||rec1.nodo||'',''''''||rec1.atributo||'''''',''||rec1.valor||'')'';
					END LOOP;
				END LOOP;

				FOR rec1 IN EXECUTE ''SELECT * FROM mate_tree('' || i || '',''||cp||'',''||nodo||'',''''''||$1||'''''')'' LOOP
					ban := rec1.mate_tree;
				END LOOP;	
                        	FOR rec1 IN EXECUTE ''SELECT max(nodo) AS mx FROM mate_nodes'' LOOP
					i := rec1.mx;
				END LOOP;	
				cp := cp -1;		
			END IF;
			IF ban = 2 THEN
				FOR rec1 IN EXECUTE ''SELECT * FROM mate_nodes WHERE nodo = ''||nodo LOOP
					numatt := rec1.herm;
				END LOOP;
				IF numatt != -1 THEN
					nodo := numatt;
					ban := 1;
				ELSE
					IF cp = 0  THEN
						ban := 0;
					ELSE
						FOR rec1 IN EXECUTE ''SELECT * FROM pg_pila WHERE num = ''||cp LOOP
							nodo := rec1.nn;
							EXECUTE ''DELETE FROM pg_pila WHERE num=''||cp;
							cp := cp - 1;
						END LOOP;
					END IF;
				END IF;
			END IF;			
		END LOOP;		
		
		
		EXECUTE ''DROP TABLE pg_pila'';
		EXECUTE ''DROP TABLE viewc1'';
		
		RETURN NEXT ''mate_rules'';
		RETURN NEXT ''mate_nodes'';
	
	ELSE
		RETURN NEXT ''LA ENTROPIA NO ES IGUAL A CERO'';
		
	END IF;
--	EXECUTE ''ALTER TABLE mate_nodes DROP COLUMN hijo'';
--	EXECUTE ''ALTER TABLE mate_nodes DROP COLUMN herm'';
RETURN;

END;'
LANGUAGE 'plpgsql' WITH (isstrict);