CREATE OR REPLACE FUNCTION test_rules(varchar) RETURNS SETOF varchar AS '
/* funcion probar_reglas recibe como parametro el modelo a probar y prueba las reglas de los modelos 
 * mate-tree y c4.5 uzando la tabla kdd_pru y en caso de no encontrarla trabaja con la tabla kdd_ent
*/
DECLARE
	
	cad		text DEFAULT NULL;
	atri		text DEFAULT NULL;
	tabla		text DEFAULT NULL;
	rel		text DEFAULT NULL;
	
	
	sql1		varchar DEFAULT NULL;	
	sql2		varchar DEFAULT NULL;	
	sql		varchar DEFAULT NULL;	

	rec_rules	record;	
	rec1		record;
	rec2		record;

	cont		integer;
	att		integer;
	at		integer;
	i		integer DEFAULT 1;
	
	prob		numeric(10,3);
	
BEGIN
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''pg_kdd_rel'''''' LOOP
		EXECUTE ''DROP TABLE pg_kdd_rel'';
	END LOOP;
	EXECUTE ''CREATE TABLE pg_kdd_rel(n int2,rel bpchar)'';
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''kdd_pru'''''' LOOP
	END LOOP;	
	IF rec1.relname IS NOT NULL THEN
		tabla := ''kdd_pru'';
	ELSE
		tabla := ''pg_kdd_tmp'';
	END IF;	
	
	FOR rec1 IN EXECUTE ''SELECT relnatts FROM pg_class WHERE pg_class.relname=''''''||tabla||'''''''' LOOP
	END LOOP;
	att := rec1.relnatts;	
	
	cont := 0;
	
	FOR rec_rules IN EXECUTE ''SELECT * FROM ''||$1||''_rules ORDER BY id,atributo'' LOOP
		
		at := rec_rules.atributo;
		
		FOR rec1 IN EXECUTE ''SELECT attname FROM pg_class,pg_attribute WHERE pg_class.relname = ''''''||tabla||'''''' AND pg_attribute.attrelid = pg_class.oid AND attnum = ''||at LOOP
		END LOOP;
		
		atri := rec1.attname;
					--RAISE NOTICE '' %'',rec_rules.atributo;
		IF rec_rules.atributo = att THEN
			--RAISE NOTICE '' % % %'',rec_rules.id,atri,sql1;
			sql1 := sql1 ||'' AND ''||atri ||'' = ''||rec_rules.valor;
			
			FOR rec1 IN EXECUTE sql1 LOOP
				cont := cont + rec1.cc;
			END LOOP;
			
			FOR rec2 IN EXECUTE sql2||'' AND ''||atri ||'' = ''||rec_rules.valor LOOP
				rel := ''[''||CAST(rec2.cc as varchar);
			END LOOP;
			
			FOR rec2 IN EXECUTE sql2 LOOP
				rel := rel||''/''||CAST(rec2.cc as varchar)||'']'';
			END LOOP;
			EXECUTE ''INSERT INTO pg_kdd_rel VALUES(''||i||'',''''''||rel||'''''')'';
			
			sql1 := NULL;
			i := i + 1;
		ELSE
	
			IF sql1 IS NULL THEN
				sql1 := ''SELECT COUNT(*) AS cc FROM ''||tabla||'' WHERE ''||atri ||'' = ''||rec_rules.valor;
				
				sql2 := ''SELECT COUNT(*) AS cc FROM pg_kdd_tmp WHERE ''||atri ||'' = ''||rec_rules.valor;
			ELSE
				sql1 := sql1 ||'' AND ''||atri ||'' = ''|| rec_rules.valor;
				sql2 := sql2 ||'' AND ''||atri ||'' = ''|| rec_rules.valor;
			END IF;	
		END IF;
		
	END LOOP;	
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''kdd_pru'''''' LOOP
		EXECUTE ''DROP TABLE kdd_pru'';
	END LOOP;
	sql := CAST(cont as varchar);
		
	RETURN NEXT sql;
		
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);

