package paquetes;
/*
 * createTree.java
 *
 * Created on 30 de agosto de 2016, 11:14 AM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

/**
 *
 *
 */
import java.util.Stack;
import javax.swing.Icon;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.TreeSelectionModel;
import paquetes.Modeltree;

/**
 * Clase que representa los nodos del árbol de reglas.
 *
 * @author Tariy
 */
public class createTree {
    String name;
    String nodo;
    createTree dad;
    createTree son;
    createTree bro;
    
    /** Construye una nueva instancia de createTree. */
    public createTree(String name) {
        this.name = name;
        this.dad = null;
        this.son = null;
        this.bro = null;
    }
    
    public createTree(String name, createTree f){
        this.name = name;
        this.dad = f;
        this.son = null;
        this.bro = null;
    }

    public createTree(String name, String nodo, createTree f){
        this.name = name;
        this.dad = f;
    ///    System.out.println("create +nodo"+nodo);
        this.nodo = nodo;
        this.son = null;
        this.bro = null;
    }
    
    public createTree(createTree f){
        this.name = f.name;
        this.dad = f.dad;
        this.son = f.son;
        this.bro = f.bro;
    //    this.nodo = f.nodo;

    }
    /**
     * Método que adiciona un nodo al árbol de reglas, ya sea como hijo o como
     * hermano.
     *
     * @param String name El valor de la cadena a mostrar en el árbol de reglas.
     *
     * @return La referencia del nuevo nodo insertado.
     */
   public createTree addSon(String name,String nod) {
        // Si el nodo no tiene hijos se inserta el nodo como hijo a su
        // puntero son.
        if(this.son == null) {
            
            this.son = new createTree(name,nod, this);            
            //System.out.println("addson "+this.son.nodo);
            return this.son;
        } else {
            // Si el nodo ya tiene hijos, el nuevo nodo se debe insertar como
            // hermano, recorremos los hermanos hasta encontrar la posicion.
            createTree aux2 = null;
            createTree aux1 = this.son;
            while(aux1 != null){
                aux2 = aux1;
                aux1 = aux1.bro;
            }
            aux2.bro = new createTree(name,nod, this);
            return aux2.bro;
        }
    }
    
   
    /**
     * Determina si este nodo es padre de child.
     *
     * @param String child El nodo a buscar en el árbol de reglas.
     *
     * @return La referencia en el árbol del hijo encontrado; en caso contrario
     *         la referencia del mismo nodo.
     */
    public createTree isFatherOf(String child) {
        // Me ubico en el primer hijo del nodo.
        createTree hijo = this.son;
        while (hijo != null) {
            // Si alguno de los hijos de este nodo coincide con el nodo child,
            // child ya existia.
            if (hijo.name.equals(child)) {
                return hijo;
            }
            hijo = hijo.bro;
        }
        return this;
    }
    
    public String toString() {
        return this.name;
    }
    
    public String getnodo() {
        return this.nodo;
    }
    //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
    //||||||||||||||||||| TreeModel implemented methods ||||||||||||||||||||||
    //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

    // Métodos utilizados por la clase createTreeModel, se complementan alla.
    
    /**
     * Retorna el hijo de un nodo de acuerdo a un indice.
     *
     * @param int index El indice del nodo a buscar.
     */
    public createTree getChild(int index) {
        createTree node = this.son;
        int count = 0;
        
        while(count < index) {
            node = node.bro;
            count++;
        }
        return node;
    }
    
    /**
     * Retorna el número de hijos de un nodo.
     */
    public int getChildCount() {
        createTree node = this.son;
        int children = 1;
        
        while(node.bro != null) {
            node = node.bro;
            children++;
        }
        return children;
    }
    
    /**
     * Retorna el indice de un nodo.
     *
     * @param Object child El nodo del cual se quiere el indice.
     */
    public int getIndexOfChild(Object child) {
        createTree node = this.son;
        int index = 0;
        
        while(node.bro != null) {
            node = node.bro;
            if(node.equals(child)) {
                break;
            }
            else {
                index++;
            }
        }
        return index;
    }
    
    /**
     * Retorna el hijo de un nodo.
     */
    public createTree isLeaf() {
        createTree node = this;
        return node.son;
    }
}


