CREATE OR REPLACE FUNCTION C45(varchar) RETURNS SETOF varchar AS' --clase
DECLARE
	i		integer;  --contador tabla c45_nodes
	numatt	integer;	
	nodo		integer;  --nodo actual
	ban		integer;  --bandera para el recorrido del arbol
	cp		integer;  --contador de pg_pila
		
	Ent		numeric;	
	Gan		numeric;
	G_may		numeric :=0;
	
	sql		text DEFAULT '''';
	txt		text DEFAULT '''';
	rta		text DEFAULT NULL;
			
	rec1		record;
	rec2		record;	
	
BEGIN
	
--**CREA TABLA DE REGLAS

	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''c45_rules'''''' LOOP
		EXECUTE ''DROP TABLE c45_rules'';
	END LOOP;		
	EXECUTE ''CREATE TABLE c45_rules (id int2, atributo int2,valor int2)'';	

--**CREA TABLA AUXILIAR pg_pila

	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''pg_pila'''''' LOOP
		EXECUTE ''DROP TABLE pg_pila'';
	END LOOP;		
	EXECUTE ''CREATE TABLE pg_pila(num int2, nn int2, att varchar,valor int2)'';	

--** CREA VISTA
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''viewc1'''''' LOOP
		EXECUTE ''DROP VIEW viewc1'';
	END LOOP;		
	EXECUTE ''CREATE VIEW viewc1 AS SELECT * FROM kdd_ent'';	
	
	EXECUTE ''INSERT INTO pg_pila VALUES (0,0,'''''' || $1 || '''''',-1)'';
	
--**CALCULA LA ENTROPIA DE LA CLASE
	
	FOR rec1 IN EXECUTE ''SELECT entro AS Ent FROM c45_entro(0,'''''' || $1 || '''''')'' LOOP
	END LOOP;
	Ent := rec1.Ent; 	
	
	IF (Ent > 0) THEN
		i := 0;
	
--**DEFINIR LA RAIZ DEL ARBOL

		sql := ''SELECT attname,attnum FROM pg_class,pg_attribute WHERE ''
			 ||''pg_class.relname=''''viewc1''''''	
			 || '' AND pg_attribute.attrelid =  pg_class.oid AND attname !=''''''
			 || $1 || '''''' AND attnum >0 ORDER BY attnum'';
		--RAISE NOTICE ''%'',sql;
		FOR rec1 IN EXECUTE sql LOOP
			EXECUTE ''INSERT INTO pg_pila VALUES(1,0,'''''' || rec1.attname || '''''',-1)'';
		
			FOR rec2 IN EXECUTE ''SELECT * FROM c45_gain(0,'' || Ent ||'',''''''||$1||'''''')'' LOOP
			END LOOP;
			Gan := rec2.entro; 
			
			IF Gan > G_may THEN				
				G_may := Gan;
				txt := rec1.attname;
				numatt := rec1.attnum;
			END IF;		
			EXECUTE ''DELETE FROM pg_pila WHERE num=1'';			
		END LOOP;		
		cp := 0;

--**CREAR NODO RAIZ
		
		FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''c45_nodes'''''' LOOP
			EXECUTE ''DROP TABLE c45_nodes'';	
		END LOOP;
				
		EXECUTE ''CREATE TABLE c45_nodes (nodo int2,padre int2,atributo bpchar,valor int2,hijo int2, herm int2,clase int2)'';

		EXECUTE ''INSERT INTO c45_nodes VALUES(0,-1,'''''' || txt || '''''',-1,-1,-1,-1)'';
				
		FOR rec1 IN EXECUTE ''SELECT ''||txt||'' AS at FROM viewc1 GROUP BY ''||txt LOOP		
			i := i + 1;
			EXECUTE ''INSERT INTO c45_nodes VALUES(''||i||'',0,'''''' || txt || '''''',''
				||rec1.at||'',-1,''||(i+1)||'',-1)'';									
		END LOOP;		
		EXECUTE ''UPDATE c45_nodes SET herm = -1 WHERE nodo=''||i;

		ban := 1;
		nodo := 1;
		WHILE (ban != 0) LOOP		
			IF ban = 1 THEN
				FOR rec1 IN EXECUTE ''SELECT * FROM c45_nodes WHERE nodo = ''||nodo LOOP
					numatt := rec1.hijo;
					cp := cp +1;
					EXECUTE ''INSERT INTO pg_pila VALUES(''||cp||'',''||rec1.nodo||'',''''''||rec1.atributo||'''''',''||rec1.valor||'')'';
				END LOOP;		

				WHILE (numatt != -1) LOOP
					nodo := rec1.hijo;
					FOR rec1 IN EXECUTE ''SELECT * FROM c45_nodes WHERE nodo = ''||nodo LOOP
						numatt := rec1.hijo;
						cp := cp +1;
						EXECUTE ''INSERT INTO pg_pila VALUES(''||cp||'',''||rec1.nodo||'',''''''||rec1.atributo||'''''',''||rec1.valor||'')'';
					END LOOP;
				END LOOP;

				FOR rec1 IN EXECUTE ''SELECT * FROM c45_tree('' || i || '',''||cp||'',''||nodo||'',''''''||$1||'''''')'' LOOP
					ban := rec1.c45_tree;
				END LOOP;	
                        FOR rec1 IN EXECUTE ''SELECT max(nodo) AS mx FROM c45_nodes'' LOOP
					i := rec1.mx;
				END LOOP;	
				cp := cp -1;		
			END IF;
			IF ban = 2 THEN
				FOR rec1 IN EXECUTE ''SELECT * FROM c45_nodes WHERE nodo = ''||nodo LOOP
					numatt := rec1.herm;
				END LOOP;
				IF numatt != -1 THEN
					nodo := numatt;
					ban := 1;
				ELSE
					IF cp = 0  THEN
						ban := 0;
					ELSE
						FOR rec1 IN EXECUTE ''SELECT * FROM pg_pila WHERE num = ''||cp LOOP
							nodo := rec1.nn;
							EXECUTE ''DELETE FROM pg_pila WHERE num=''||cp;
							cp := cp - 1;
						END LOOP;
					END IF;
				END IF;
			END IF;			
		END LOOP;		
		
		
		EXECUTE ''DROP TABLE pg_pila'';
		EXECUTE ''DROP VIEW viewc1'';
		
		RETURN NEXT ''c45_rules'';
		RETURN NEXT ''c45_nodes'';
	
	ELSE
		RETURN NEXT ''LA ENTROPIA NO ES IGUAL A CERO'';
		
	END IF;
	--EXECUTE ''ALTER TABLE c45_nodes DROP COLUMN hijo'';
	--EXECUTE ''ALTER TABLE c45_nodes DROP COLUMN herm'';
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);