CREATE OR REPLACE FUNCTION entro(varchar) RETURNS SETOF numeric AS '--clase
DECLARE
	cont	integer DEFAULT 0;
			
	val_ln2		numeric := 0.69314718055994530942; 
	val_fraccion	numeric;
	val_entro	numeric;
	
	sql		text DEFAULT '''';
	cad		text DEFAULT NULL;
	cad1		text DEFAULT NULL;
	join	text DEFAULT NULL;
		
	
	rec1		record;
	rec2		record;
	rec3		record;
	
BEGIN

--**TERMINAR TRANSFORMACION

	FOR rec1 IN EXECUTE ''SELECT atributo,valor,discret FROM kdd_values'' LOOP		
		sql := ''UPDATE kdd_clase SET ''||rec1.atributo||'' = -1''; 
		sql := sql || '' WHERE ''||rec1.atributo||'' IS NULL'';
		EXECUTE sql;		
	END LOOP;

--****	CREA TABLA mate_entro
	
	sql := ''SELECT attname, attnum, relnatts FROM pg_class, pg_attribute''
		 || '' WHERE pg_class.relname = ''''kdd_ent''''''
	 	|| '' AND pg_attribute.attrelid = pg_class.oid''
		|| '' AND attname !=''''''||$1||''''''''
		|| '' AND attnum > 0 ORDER BY attnum'';
	
	FOR rec1 IN EXECUTE sql LOOP
	
		IF cad ISNULL THEN
			cad := ''t1.''||rec1.attname;
			join := ''t1.''||rec1.attname||'' = t2.''||rec1.attname;
		ELSE
			cad := cad ||'',t1.''|| rec1.attname;
			join := join ||'' AND ''|| ''t1.''||rec1.attname||'' = t2.''||rec1.attname;
		END IF;
	
	END LOOP;
		
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''mate_entro'''''' LOOP
		EXECUTE ''DROP TABLE mate_entro'';
	END LOOP;
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''kdd_entro'''''' LOOP
		EXECUTE ''DROP TABLE kdd_entro'';
	END LOOP;
	
--** CREA LA TABLA Q GUARDA LAS DIFERENTES COMBINACIONES
	EXECUTE ''CREATE TABLE mate_entro AS SELECT ''||cad||'' FROM kdd_clase t1 GROUP BY ''||cad;	
	EXECUTE ''ALTER TABLE kdd_clase ADD COLUMN entro numeric(4,4)'';
	
--****PROCESO DE GENERACION DE ENTROPIAS
	
	FOR rec3 IN EXECUTE ''SELECT ctid FROM mate_entro'' LOOP
		
		cad1 := rec3.ctid;
		
		sql := ''SELECT SUM(t1.count) AS sum FROM kdd_clase t1, mate_entro t2 WHERE ''||join||'' AND t2.ctid=''''''||cad1||'''''''';
		
		
		FOR rec1 IN EXECUTE sql LOOP
			cont:= rec1.sum;		
			val_entro := 0;
			FOR rec2 IN EXECUTE ''SELECT t1.count AS con, t1.ctid AS t FROM kdd_clase t1, mate_entro t2 WHERE ''||join||'' AND t2.ctid=''''''||cad1||'''''''' LOOP
				val_fraccion := CAST(rec2.con as numeric)/CAST(cont as numeric); 
				val_entro := (((val_fraccion) * ln(val_fraccion))/val_ln2) * -1;
				cad1 := rec2.t;
				EXECUTE ''UPDATE kdd_clase SET entro=''||val_entro||'' WHERE ctid=''''''||cad1||'''''''';
			END LOOP;			
		END LOOP;
		
	END LOOP;
	
	EXECUTE ''DROP TABLE mate_entro'';
	EXECUTE ''CREATE TABLE mate_entro AS SELECT * FROM kdd_clase'';
	EXECUTE ''DROP TABLE kdd_clase'';
		
	FOR rec1 IN EXECUTE ''SELECT count(*) AS con FROM kdd_ent'' LOOP
	END LOOP;

	cont := rec1.con;
	sql := ''SELECT count(*) AS cc FROM kdd_ent GROUP BY '' || $1;
	val_entro :=0;

	FOR rec1 IN EXECUTE sql LOOP
		val_fraccion := CAST(rec1.cc as numeric)/CAST(cont as numeric);
		val_entro := val_entro - (((val_fraccion) * ln(val_fraccion))/val_ln2);		
	END LOOP;
	
	EXECUTE ''CREATE TABLE kdd_entro AS SELECT * FROM kdd_ent'';
	EXECUTE ''DELETE FROM kdd_entro'';
	EXECUTE ''ALTER TABLE kdd_entro ADD COLUMN count numeric'';
	EXECUTE ''ALTER TABLE kdd_entro ADD COLUMN entro numeric'';
	EXECUTE ''COPY mate_entro TO ''''/tmp/classe.txt'''' using delimiters '''','''''';
	EXECUTE ''DROP TABLE mate_entro'';
	EXECUTE ''COPY kdd_entro FROM ''''/tmp/classe.txt'''' using delimiters '''','''''';

	RETURN NEXT val_entro;
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);