CREATE OR REPLACE FUNCTION purify(varchar) RETURNS SETOF varchar AS '--Tabla
/* Funcion que depura una tabla, recibe como parametro el nombre de la tabla a depurar y como resultado 
 * crea la tabla kdd_list
*/
DECLARE
	
	i		integer;
	cont		numeric;
	
	sql		text DEFAULT '''';
	cad		text DEFAULT NULL;
	att		text DEFAULT NULL;
		
	rec1		record;
	rec2		record;
	
BEGIN

--****	CREA TABLA kdd_list

	sql := ''SELECT attname,typname FROM pg_class, pg_attribute,pg_type''
		|| '' WHERE pg_class.relname = ''''''||$1||''''''''
		|| '' AND pg_attribute.attrelid = pg_class.oid''
		|| '' AND pg_type.oid=pg_attribute.atttypid AND attnum > 0 ORDER BY attnum'';
	
	FOR rec1 IN EXECUTE sql LOOP
	
		IF cad ISNULL THEN
			cad := rec1.attname||'' ''||rec1.typname;	
			
		ELSE	
			cad := cad ||'',''|| rec1.attname||'' ''||rec1.typname;
			
		END IF;
	
	END LOOP;
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname =''''kdd_list'''''' LOOP
		EXECUTE ''DROP TABLE kdd_list'';	
	END LOOP;
		
	EXECUTE ''CREATE TABLE kdd_list(''||cad||'')'';	
	
	EXECUTE ''INSERT INTO kdd_list SELECT * FROM ''||$1;

--***PROCESO DE DEPURACION
	
	sql := ''SELECT attname, atttypid FROM pg_class, pg_attribute WHERE pg_class.relname = ''''kdd_list''''''
		|| '' AND pg_attribute.attrelid = pg_class.oid''
		|| '' AND attnum > 0 ORDER BY attnum'';
	
	FOR rec1 IN EXECUTE sql LOOP
	
		FOR rec2 IN EXECUTE ''SELECT COUNT(*) AS cc FROM kdd_list WHERE ''||rec1.attname||'' IS NULL'' LOOP
			cont := rec2.cc;
		END LOOP;
		
		IF cont > 0 THEN
		RAISE NOTICE ''%  %'',rec1.attname,rec1.atttypid;
			IF rec1.atttypid = 20 OR rec1.atttypid = 21 OR rec1.atttypid = 22 OR rec1.atttypid = 23 OR rec1.atttypid = 700 OR rec1.atttypid = 1700 OR rec1.atttypid = 701 THEN
			   
			   sql := ''SELECT ''||rec1.attname||'' AS vl FROM kdd_list WHERE ''||rec1.attname||'' IS NOT NULL'';
			   cont := 0;
			   FOR rec2 IN EXECUTE sql LOOP
			   	cont := cont + rec2.vl;
			   END LOOP;
			   
			   sql := ''SELECT COUNT(*) AS cc FROM kdd_list WHERE ''||rec1.attname||'' IS NOT NULL'';
			   FOR rec2 IN EXECUTE sql LOOP
			   	cont := cont / rec2.cc;
			   END LOOP;
			   
			   sql := ''UPDATE kdd_list SET ''||rec1.attname||''=''||cont||'' WHERE ''||rec1.attname||'' IS NULL'';
			   EXECUTE sql;
			
			ELSE
			   
			   sql := ''SELECT ''||rec1.attname||'' AS nm,COUNT(*) AS cc FROM kdd_list WHERE ''||rec1.attname||'' IS NOT NULL GROUP BY ''||rec1.attname;
			   cont := 0;
			   FOR rec2 IN EXECUTE sql LOOP
			   	IF rec2.cc > cont THEN
					cont := rec2.cc;
					att := rec2.nm;
				END IF;
			   END LOOP;
			   
			   sql := ''UPDATE kdd_list SET ''||rec1.attname||''=''''''||att||'''''' WHERE ''||rec1.attname||'' IS NULL'';
			   EXECUTE sql;
			
			END IF;
		END IF;
	
	END LOOP;	
	
	RETURN NEXT ''CREADA LA TABLA kdd_list'';
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);