CREATE OR REPLACE FUNCTION transform(varchar) RETURNS SETOF varchar AS ' 
/* funcion transform recibe como parametro el nombre del atributo clase, trabaja con la tabla 
* kdd_list y como resultado crea las tablas kdd_values y kdd_ent
*/
DECLARE
	
	i		integer;
	j		integer;	
		
	qry_sql		text DEFAULT '''';
	qry_sql2	text DEFAULT '''';
	qry_sql3	text DEFAULT '''';
	cad_var		text DEFAULT NULL;
	cad		text DEFAULT NULL;
	cad_int		text DEFAULT NULL;	
	flag_val	text DEFAULT NULL;
	
	rec_at		record;	
	rec_att		record;		
	
BEGIN

--****	CREA TABLA kdd_ent
	
	qry_sql := ''SELECT attname, attnum, relnatts FROM pg_class, pg_attribute'';
	qry_sql := qry_sql || '' WHERE pg_class.relname = ''''kdd_list'''''';
	qry_sql := qry_sql || '' AND pg_attribute.attrelid = pg_class.oid AND attname!=''''''||$1;
	qry_sql := qry_sql || '''''' AND attnum > 0 ORDER BY attnum'';
	
	FOR rec_at IN EXECUTE qry_sql LOOP
	
		IF cad_var ISNULL THEN
			cad_var := rec_at.attname||'' bpchar'';
			cad_int := rec_at.attname||'' int2'';
			cad := rec_at.attname;
			
		ELSE
			
			cad_var := cad_var ||'' , ''|| rec_at.attname||'' bpchar'';
			cad_int := cad_int ||'' , ''|| rec_at.attname||'' int2'';
			cad := cad || '','' || rec_at.attname;
		END IF;
	
	END LOOP;	
	cad_var := cad_var || '','' || $1 || '' bpchar'';
	cad_int := cad_int || '',''|| $1 || '' int'';
	cad := cad || '','' || $1;
	
	SELECT INTO flag_val relname FROM pg_class WHERE relname = ''kdd_ent'';
	IF flag_val IS NOT NULL THEN
		EXECUTE ''DROP TABLE kdd_ent'';	
	END IF;
	
	EXECUTE ''CREATE TABLE kdd_ent (''||cad_var||'')'';
	EXECUTE ''INSERT INTO kdd_ent SELECT ''||cad||'' FROM kdd_list'';

			
--****	CREA TABLA kdd_values
	
	SELECT INTO flag_val relname FROM pg_class WHERE relname = ''kdd_values'';
	IF flag_val IS NOT NULL THEN
		EXECUTE ''DROP TABLE kdd_values'';
	END IF; 
	EXECUTE ''CREATE TABLE kdd_values(nro int2,atributo varchar,valor varchar,discret varchar,nclases int2)'';
		
	j=1;
	qry_sql := ''SELECT attname FROM pg_class, pg_attribute'';
	qry_sql := qry_sql || '' WHERE pg_class.relname = ''''kdd_ent'''''';
	qry_sql := qry_sql || '' AND pg_attribute.attrelid = pg_class.oid'';
	qry_sql := qry_sql || '' AND attnum > 0 AND attnum <= relnatts ORDER BY attnum'';
	
	FOR rec_at IN EXECUTE qry_sql LOOP
		
		i := 0;
		qry_sql2 := ''SELECT DISTINCT ''||rec_at.attname||'' AS val FROM kdd_ent '';
		qry_sql2 := qry_sql2 || ''WHERE ''||rec_at.attname||'' IS NOT NULL GROUP BY val'';
		
		FOR rec_att IN EXECUTE qry_sql2 LOOP
			
			qry_sql3 := ''INSERT INTO kdd_values (nro,atributo,valor,discret) VALUES ''; 
			qry_sql3 := qry_sql3 || ''(''||j||'',''''''||rec_at.attname||'''''',''''''||rec_att.val||'''''',''''''||i||'''''')'';
			EXECUTE qry_sql3;
			i := i + 1;
			j := j + 1;
			
		END LOOP;
		
		qry_sql3 := ''UPDATE kdd_values SET nclases = ''||i||'' WHERE nro = ''||j-1;
		EXECUTE qry_sql3;
		
	END LOOP;
		
--****	PROCESO DE TRANSFORMACION DE kdd_ent
	
	FOR rec_at IN EXECUTE ''SELECT atributo,valor,discret FROM kdd_values'' LOOP
		
		qry_sql := ''UPDATE kdd_ent SET ''||rec_at.atributo||'' = ''||rec_at.discret||''''; 
		qry_sql := qry_sql || '' WHERE ''||rec_at.atributo||'' = ''''''||rec_at.valor||'''''''';
		EXECUTE qry_sql;
		
		qry_sql := ''UPDATE kdd_ent SET ''||rec_at.atributo||'' = -1''; 
		qry_sql := qry_sql || '' WHERE ''||rec_at.atributo||'' IS NULL'';
		EXECUTE qry_sql;
		
	END LOOP;
	
	EXECUTE ''COPY kdd_ent TO ''''/tmp/classi.txt'''' using delimiters '''','''' '';
	EXECUTE ''DROP TABLE kdd_ent'';
	EXECUTE ''CREATE TABLE kdd_ent (''||cad_int||'')''; 
	EXECUTE ''COPY kdd_ent FROM ''''/tmp/classi.txt'''' using delimiters '''','''' '';
	
	EXECUTE ''DROP TABLE kdd_list'';
		
	RETURN NEXT ''CREATE TABLE kdd_values'';
	RETURN NEXT ''CREATE TABLE kdd_ent'';
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);