#include "arbol.h"

int nclases,x;

/* Funcion que inicia todos los valores de la matriz en -1*/
void inicializarMatriz(int ***matriz,int numAttr){
	int i;
	
	for(i=0; i<numAttr; i++){
		(*matriz)[0][i]=-1;
		(*matriz)[1][i]=-1;
	}
}

/* Funcion que no inserta el atributo(vmatriz[0][?]) y valor(matriz[1][?])
 * de un nodo en la Matriz. Controla que en la matriz no hayan 
 * atributos(matriz[0][?]) repetidos
 */
int insertarMatriz(int ***matriz, int attr, int val, int numAttr){
	int i,j=0;

	for(i=0; i<numAttr; i++) {
		if(attr == (*matriz)[0][i]){
			j=0;break;
		}
		else if (attr != (*matriz)[0][i] && (*matriz)[0][i]==-1){
			(*matriz)[0][i]= attr;
			(*matriz)[1][i]=val;
			j= 1;
			break;
		}
	}
	return j;
}

/* Funcion que elimina el ultimo atributo(matriz[0][?]) de la matriz */
void eliminarUltimo(int ***matriz, int attr, int numAttr){
	int i,j=0;

	for(i=0; i<numAttr; i++) {
		if(attr == (*matriz)[0][i]){
			j=1;break;
		}		
	}
	if (j==1){
			(*matriz)[0][i]= -1;
			(*matriz)[1][i]=-1;
	}
}

/* Funcion que recorre el Arbol e inserta los
 * atributos(matriz[0][?]) y valores(matriz[1][?]) a la matriz.
 */
void recorrerArbol(int ***matriz, NodoArbol * raiz, int numAttr, NodoArbol * aux)
{
	int i,j=0;
	static int s=0;
	
	if (raiz->nHijos) {
		for(j=0; j < aux->nHijos; j++)
			if (aux->hijos[j].etiqueta == -1) break;
		
		if (j == aux->nHijos){
			eliminarUltimo(matriz,aux->padre->atributo,numAttr);
			aux->etiqueta=-999;
			s=0;
			//elog(INFO,"aux->atributo=%d",aux->atributo);			
			//return;
		}
		else{
			for (i = 0; i < raiz->nHijos; i++){
				if (raiz->hijos[i].etiqueta == -1){
					if (insertarMatriz(matriz,raiz->atributo,raiz->hijos[i].valor,numAttr)){
						s=1;
						aux = &raiz->hijos[i];				
					}
					recorrerArbol(matriz,&raiz->hijos[i],numAttr,aux);
				}
			}
			if(s==0 && raiz->padre != NULL){
				eliminarUltimo(matriz,raiz->padre->atributo,numAttr);	
				aux->etiqueta=-999;
				//return;
			}
		}
	}
}

/* Funcion que crea el nodo padre */
void crearNodo(NodoArbol * raiz,int vecdec[],int NCLASES,int numClases[]){
	int j;
	nclases = NCLASES;
	
	raiz->atributo=vecdec[0];
	if (raiz->padre==NULL)
		raiz->valor = -1;
	raiz->etiqueta=-1;
	raiz->nHijos = numClases[vecdec[0]];
	raiz->hijos = nuevoArreglo(NodoArbol, raiz->nHijos);
	
	for (j = 0; j < raiz->nHijos; j++)
		crearNodoHijo(raiz, vecdec, j);
}

/* Funcion que crea los nodos hijos, y le asigna los valores dados
 * en el vector decision(vecdec) */
void crearNodoHijo(NodoArbol * raiz, int vecdec[],int j)
{
	int i,s=0;
    NodoArbol *hijo;

    hijo = &raiz->hijos[j];
    for(i=0; i<nclases; i++) {
    	if(i==vecdec[j+1] || vecdec[j+1]==-999)	{
    		s=1;
    		break;
    	}	
    }
    
    if (s==1){
    	hijo->atributo=-1;
	    hijo->valor = j;
    	hijo->etiqueta=vecdec[j+1];
	}
    else{
    	hijo->atributo=-1;
	    hijo->valor = j;
    	hijo->etiqueta=-1;
    }
	hijo->padre = raiz;
    hijo->nHijos = 0;
    hijo->hijos = NULL;
}

/* Funcion que busca en el arbol el nodo al cual se pueden
 * agregar nodos hijos
 */
void encontrarNodo(NodoArbol * raiz,int vecdec[],int NCLASES,int numClases[]){
	int i;
	
	if (raiz->etiqueta ==-1 &&  raiz->atributo == -1 && raiz->padre!=NULL){
		if (vecdec[0] != raiz->padre->atributo) 
			crearNodo(raiz,vecdec,nclases,numClases);
		else
			raiz->etiqueta=-999;
		x=1;
	}

	if (raiz->nHijos) {
		for (i = 0; i < raiz->nHijos; i++) 
			if (x==0){
	            encontrarNodo(&raiz->hijos[i], vecdec, nclases, numClases);
			}
	}
}

/* Funciones para mostrar el arbol en pantalla */
void mostrarArbol(NodoArbol * raiz){
	int i;
	
	elog(INFO,"attr=%d val=%d  etiq=%d numHijos=%d", raiz->atributo, raiz->valor, raiz->etiqueta, raiz->nHijos);

	if (raiz->nHijos) {
		for (i = 0; i < raiz->nHijos; i++) 
            mostrarArbol(&raiz->hijos[i]);
	}
}

void iniciarX(int cero){
	x=cero;
}

/* Funciones para LIBERRAR MEMORIA */
void liberarMatriz(int **matriz,int numAttr){
	liberar(matriz[0]);
    liberar(matriz[1]);
    	
   	liberar(matriz);
}

void liberarArbol(NodoArbol * raiz){
        int i;
        
        if (raiz->nHijos) {
			for (i = 0; i < raiz->nHijos; i++){
	  			liberarArbol(&raiz->hijos[i]);
			}
        }
       	liberar(&raiz);
}
