CREATE OR REPLACE FUNCTION entro(varchar) RETURNS SETOF varchar AS '
DECLARE
	cont_reg	integer;
	ini		integer;
	ini_sig		integer;
	ini_pos		integer;
	fin		integer;
	i		integer;
	j		integer;
	cont		integer;
	flag 		integer;
		
	val_ln2		numeric := 0.69314718055994530942; 
	val_fraccion	numeric;
	val_entro	numeric(4,0);
	
	qry_sql		text DEFAULT '''';
	qry_sql2	text DEFAULT '''';
	qry_sql3	text DEFAULT '''';
	cad_var		text DEFAULT NULL;
	cad_int		text DEFAULT NULL;
	cad_join	text DEFAULT NULL;
	flag_val	text DEFAULT NULL;
	
	rec_at		record;
	rec_att		record;
	rec_comp	record;
	rec_comp2	record;
	
BEGIN
	--****	CREA TABLA mate_entro
	
	qry_sql := ''SELECT attname, attnum, relnatts FROM pg_class, pg_attribute'';
	qry_sql := qry_sql || '' WHERE pg_class.relname = ''''''||$1||'''''''';
	qry_sql := qry_sql || '' AND pg_attribute.attrelid = pg_class.oid'';
	qry_sql := qry_sql || '' AND attnum > 0 ORDER BY attnum'';
	
	FOR rec_at IN EXECUTE qry_sql LOOP
	
		IF cad_var ISNULL THEN
			cad_var := rec_at.attname||'' bpchar'';
			cad_int := rec_at.attname||'' int2'';
			cad_join := ''t1.''||rec_at.attname||'' = t2.''||rec_at.attname;
		ELSE
			IF rec_at.attnum < rec_at.relnatts THEN
				cad_var := cad_var ||'' , ''|| rec_at.attname||'' bpchar'';
			ELSE
				cad_var := cad_var ||'' , ''|| rec_at.attname||'' int2'';
			END IF;
			cad_int := cad_int ||'' , ''|| rec_at.attname||'' int2'';
			IF rec_at.attnum < rec_at.relnatts - 1 THEN
				cad_join := cad_join ||'' AND ''|| ''t1.''||rec_at.attname||'' = t2.''||rec_at.attname;
			END IF;
		END IF;
	
	END LOOP;
	cad_int := cad_int ||'' , entro int2'';
	
	SELECT INTO flag_val relname FROM pg_class WHERE relname = ''mate_entro'';
	IF flag_val ISNULL THEN
		EXECUTE ''CREATE TABLE mate_entro (''||cad_var||'')'';
		EXECUTE ''INSERT INTO mate_entro SELECT * FROM ''||$1;
	ELSE
		RAISE EXCEPTION ''La tabla de CLASIFICACION mate_entro, ya existe'';
		RETURN;
	END IF;
	--****
	
	
	--****	CREA TABLA mate_values
	
	SELECT INTO flag_val relname FROM pg_class WHERE relname = ''mate_values'';
	IF flag_val ISNULL THEN
		EXECUTE ''CREATE TABLE mate_values(nro int2,atributo varchar,valor varchar,discret varchar,nclases int2)'';
	ELSE
		RAISE EXCEPTION ''La tabla de CLASIFICACION mate_values, ya existe'';
		RETURN;
	END IF; 
	
	j=1;
	qry_sql := ''SELECT attname FROM pg_class, pg_attribute'';
	qry_sql := qry_sql || '' WHERE pg_class.relname = ''''mate_entro'''''';
	qry_sql := qry_sql || '' AND pg_attribute.attrelid = pg_class.oid'';
	qry_sql := qry_sql || '' AND attnum > 0 AND attnum < relnatts ORDER BY attnum'';
	
	FOR rec_at IN EXECUTE qry_sql LOOP
		
		i := 0;
		qry_sql2 := ''SELECT DISTINCT ''||rec_at.attname||'' AS val FROM mate_entro '';
		qry_sql2 := qry_sql2 || ''WHERE ''||rec_at.attname||'' IS NOT NULL GROUP BY val'';
		
		FOR rec_att IN EXECUTE qry_sql2 LOOP
			
			qry_sql3 := ''INSERT INTO mate_values (nro,atributo,valor,discret) VALUES ''; 
			qry_sql3 := qry_sql3 || ''(''||j||'',''''''||rec_at.attname||'''''',''''''||rec_att.val||'''''',''''''||i||'''''')'';
			EXECUTE qry_sql3;
			i := i + 1;
			j := j + 1;
			
		END LOOP;
		
		qry_sql3 := ''UPDATE mate_values SET nclases = ''||i||'' WHERE nro = ''||j-1;
		EXECUTE qry_sql3;
		
	END LOOP;
	--****
	
	
	--****	PROCESO DE TRANSFORMACION DE mate_entro
	
	FOR rec_at IN EXECUTE ''SELECT atributo,valor,discret FROM mate_values'' LOOP
		
		qry_sql := ''UPDATE mate_entro SET ''||rec_at.atributo||'' = ''||rec_at.discret||''''; 
		qry_sql := qry_sql || '' WHERE ''||rec_at.atributo||'' = ''''''||rec_at.valor||'''''''';
		EXECUTE qry_sql;
		
		qry_sql := ''UPDATE mate_entro SET ''||rec_at.atributo||'' = -1''; 
		qry_sql := qry_sql || '' WHERE ''||rec_at.atributo||'' IS NULL'';
		EXECUTE qry_sql;
		
	END LOOP;
	
	EXECUTE ''ALTER TABLE mate_entro ADD COLUMN entro numeric'';
	--****
	
	
	--****PROCESO DE GENERACION DE ENTROPIAS
	
	SELECT INTO cont_reg count(*) FROM mate_entro;
	SELECT INTO ini min(oid) as cod FROM mate_entro;
	fin := ini + (cont_reg - 1);
	flag := 0;
	
	WHILE ini <= fin LOOP
		
		cont := 0;
		flag := 0;
		ini_sig := ini + 1;
		
		WHILE ini_sig <= fin LOOP
			
			qry_sql := ''SELECT t1.count as c1,t2.count as c2 FROM mate_entro t1,mate_entro t2 '';
			qry_sql := qry_sql || ''WHERE t1.oid = ''||ini||'' AND t2.oid = ''||ini_sig||'' AND ''||cad_join;
			FOR rec_comp IN EXECUTE qry_sql LOOP
			END LOOP;
			
			IF rec_comp.c1 is null AND rec_comp.c2 is null THEN
			
				IF cont = 0 THEN
					SELECT INTO rec_comp2 * FROM mate_entro WHERE oid = ini;
					val_fraccion := CAST(rec_comp2.count as numeric)/CAST(rec_comp2.count as numeric); 
					val_entro := (((val_fraccion) * ln(val_fraccion))/val_ln2) * -1000;
					
					qry_sql := ''UPDATE mate_entro SET entro = ''||val_entro; 
					qry_sql := qry_sql || '' WHERE oid = ''||ini;
					EXECUTE qry_sql;
				ELSE
					WHILE ini < ini_sig LOOP
						
						SELECT INTO rec_comp2 * FROM mate_entro WHERE oid = ini;
						val_fraccion := CAST(rec_comp2.count as numeric)/CAST(cont as numeric); 
						val_entro := (((val_fraccion) * ln(val_fraccion))/val_ln2) * -1000;
						
						qry_sql := ''UPDATE mate_entro SET entro = ''||val_entro; 
						qry_sql := qry_sql || '' WHERE oid = ''||ini;
						EXECUTE qry_sql;
						
						ini := ini + 1;
						
					END LOOP;
				END IF;
				
				ini_pos := ini_sig;
				EXIT;
			ELSE
				IF flag = 0 THEN
					cont := rec_comp.c1 + rec_comp.c2;
					flag := 1;
				ELSE
					cont := cont + rec_comp.c2;
				END IF;
				
				ini_sig := ini_sig + 1;
			END IF;
			
		END LOOP;
		
		IF ini_sig > fin THEN
			IF cont = 0 THEN
				SELECT INTO rec_comp2 * FROM mate_entro WHERE oid = ini;
				val_fraccion := CAST(rec_comp2.count as numeric)/CAST(rec_comp2.count as numeric); 
				val_entro := (((val_fraccion) * ln(val_fraccion))/val_ln2) * -1000;
					
				qry_sql := ''UPDATE mate_entro SET entro = ''||val_entro; 
				qry_sql := qry_sql || '' WHERE oid = ''||ini;
				EXECUTE qry_sql;
			ELSE
				WHILE ini < ini_sig LOOP
				
					SELECT INTO rec_comp2 * FROM mate_entro WHERE oid = ini;
					val_fraccion := CAST(rec_comp2.count as numeric)/CAST(cont as numeric); 
					val_entro := (((val_fraccion) * ln(val_fraccion))/val_ln2) * -1000;
						
					qry_sql := ''UPDATE mate_entro SET entro = ''||val_entro; 
					qry_sql := qry_sql || '' WHERE oid = ''||ini;
					EXECUTE qry_sql;
					
					ini := ini + 1;
					
				END LOOP;
			END IF;
			EXIT;
		ELSE
			ini := ini_pos;
		END IF;
		
	END LOOP;
	--****
	
	EXECUTE ''COPY mate_entro TO ''''/tmp/classi.txt'''' using delimiters '''','''' '';
	EXECUTE ''DROP TABLE mate_entro'';
	EXECUTE ''CREATE TABLE mate_entro (''||cad_int||'')''; 
	EXECUTE ''COPY mate_entro FROM ''''/tmp/classi.txt'''' using delimiters '''','''' '';
		
	RETURN NEXT ''CREATE TABLE mate_values'';
	RETURN NEXT ''CREATE TABLE mate_entro'';
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);